/*
 * n01_stats
 *
 * filter.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <tchar.h>
#include <commctrl.h>

#include "General.h"
#include "Message.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern NAME_INFO *nmi;
extern int nmi_count;

/* Local Function Prototypes */
static BOOL CALLBACK filter_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * filter_proc - EBhEvV[W
 */
static BOOL CALLBACK filter_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	EXTRACT_INFO *exi;
	SYSTEMTIME tim;
	int i;

	switch (msg) {
	case WM_INITDIALOG:
		if ((exi = (EXTRACT_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		// R{{bNX̐ݒ
		for (i = 0; i < nmi_count; i++) {
			SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)nmi[i].name);
			SendDlgItemMessage(hDlg, IDC_COMBO_VS_NAME, CB_ADDSTRING, 0, (LPARAM)nmi[i].name);
		}
		SendDlgItemMessage(hDlg, IDC_CHECK_NAME, BM_SETCHECK, exi->filter_name_enable, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_NAME, WM_SETTEXT, 0, (LPARAM)exi->filter_name);

		SendDlgItemMessage(hDlg, IDC_CHECK_VS_NAME, BM_SETCHECK, exi->filter_vs_name_enable, 0);
		SendDlgItemMessage(hDlg, IDC_COMBO_VS_NAME, WM_SETTEXT, 0, (LPARAM)exi->filter_vs_name);

		SendDlgItemMessage(hDlg, IDC_CHECK_FILENAME, BM_SETCHECK, exi->filter_file_name_enable, 0);
		SendDlgItemMessage(hDlg, IDC_EDIT_FILENAME, WM_SETTEXT, 0, (LPARAM)exi->filter_file_name);

		SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_SETCHECK, exi->filter_date_enable, 0);
		SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_ST, DTM_SETSYSTEMTIME, 0, (LPARAM)&exi->filter_date_st);
		SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_EN, DTM_SETSYSTEMTIME, 0, (LPARAM)&exi->filter_date_en);

		SendDlgItemMessage(hDlg, IDC_CHECK_TIME, BM_SETCHECK, exi->filter_time_enable, 0);
		SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_ST_T, DTM_SETSYSTEMTIME, 0, (LPARAM)&exi->filter_date_st);
		SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_EN_T, DTM_SETSYSTEMTIME, 0, (LPARAM)&exi->filter_date_en);

		SendDlgItemMessage(hDlg, IDC_CHECK_START_SCORE, BM_SETCHECK, exi->filter_start_score_enable, 0);
		if (exi->filter_start_score <= 0) {
			SetDlgItemInt(hDlg, IDC_EDIT_START_SCORE, 501, FALSE);
		} else {
			SetDlgItemInt(hDlg, IDC_EDIT_START_SCORE, exi->filter_start_score, FALSE);
		}
		SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECK_NAME, 0);
		SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECK_VS_NAME, 0);
		SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECK_FILENAME, 0);
		SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECK_DATE, 0);
		SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECK_START_SCORE, 0);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_CHECK_NAME:
			EnableWindow(GetDlgItem(hDlg, IDC_COMBO_NAME), SendDlgItemMessage(hDlg, IDC_CHECK_NAME, BM_GETCHECK, 0, 0));
			break;

		case IDC_CHECK_VS_NAME:
			EnableWindow(GetDlgItem(hDlg, IDC_COMBO_VS_NAME), SendDlgItemMessage(hDlg, IDC_CHECK_VS_NAME, BM_GETCHECK, 0, 0));
			break;

		case IDC_CHECK_FILENAME:
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_FILENAME), SendDlgItemMessage(hDlg, IDC_CHECK_FILENAME, BM_GETCHECK, 0, 0));
			break;

		case IDC_CHECK_DATE:
			EnableWindow(GetDlgItem(hDlg, IDC_DATETIMEPICKER_ST), SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_GETCHECK, 0, 0));
			EnableWindow(GetDlgItem(hDlg, IDC_DATETIMEPICKER_EN), SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_GETCHECK, 0, 0));
			EnableWindow(GetDlgItem(hDlg, IDC_CHECK_TIME), SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_GETCHECK, 0, 0));
			if (SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_GETCHECK, 0, 0) == 0) {
				EnableWindow(GetDlgItem(hDlg, IDC_DATETIMEPICKER_ST_T), 0);
				EnableWindow(GetDlgItem(hDlg, IDC_DATETIMEPICKER_EN_T), 0);
			} else {
				SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECK_TIME, 0);
			}
			break;

		case IDC_CHECK_TIME:
			EnableWindow(GetDlgItem(hDlg, IDC_DATETIMEPICKER_ST_T), SendDlgItemMessage(hDlg, IDC_CHECK_TIME, BM_GETCHECK, 0, 0));
			EnableWindow(GetDlgItem(hDlg, IDC_DATETIMEPICKER_EN_T), SendDlgItemMessage(hDlg, IDC_CHECK_TIME, BM_GETCHECK, 0, 0));
			break;

		case IDC_CHECK_START_SCORE:
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_START_SCORE), SendDlgItemMessage(hDlg, IDC_CHECK_START_SCORE, BM_GETCHECK, 0, 0));
			break;

		case IDOK:
			exi = (EXTRACT_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
			if (exi == NULL) {
				EndDialog(hDlg, FALSE);
				break;
			}
			exi->filter_name_enable = SendDlgItemMessage(hDlg, IDC_CHECK_NAME, BM_GETCHECK, 0, 0);
			SendDlgItemMessage(hDlg, IDC_COMBO_NAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)exi->filter_name);

			exi->filter_vs_name_enable = SendDlgItemMessage(hDlg, IDC_CHECK_VS_NAME, BM_GETCHECK, 0, 0);
			SendDlgItemMessage(hDlg, IDC_COMBO_VS_NAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)exi->filter_vs_name);

			exi->filter_file_name_enable = SendDlgItemMessage(hDlg, IDC_CHECK_FILENAME, BM_GETCHECK, 0, 0);
			SendDlgItemMessage(hDlg, IDC_EDIT_FILENAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)exi->filter_file_name);

			exi->filter_date_enable = SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_GETCHECK, 0, 0);
			exi->filter_time_enable = SendDlgItemMessage(hDlg, IDC_CHECK_TIME, BM_GETCHECK, 0, 0);

			SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_ST, DTM_GETSYSTEMTIME, 0, (LPARAM)&exi->filter_date_st);
			if (exi->filter_date_enable == 0 || exi->filter_time_enable != 0) {
				SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_ST_T, DTM_GETSYSTEMTIME, 0, (LPARAM)&tim);
			} else {
				ZeroMemory(&tim, sizeof(SYSTEMTIME));
			}
			exi->filter_date_st.wHour = tim.wHour;
			exi->filter_date_st.wMinute = tim.wMinute;
			exi->filter_date_st.wSecond = tim.wSecond;
			exi->filter_date_st.wMilliseconds = 0;

			SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_EN, DTM_GETSYSTEMTIME, 0, (LPARAM)&exi->filter_date_en);
			if (exi->filter_date_enable == 0 || exi->filter_time_enable != 0) {
				SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_EN_T, DTM_GETSYSTEMTIME, 0, (LPARAM)&tim);
			} else {
				tim.wHour = 23;
				tim.wMinute = 59;
				tim.wSecond = 59;
			}
			exi->filter_date_en.wHour = tim.wHour;
			exi->filter_date_en.wMinute = tim.wMinute;
			exi->filter_date_en.wSecond = tim.wSecond;
			exi->filter_date_en.wMilliseconds = 0;

			exi->filter_start_score_enable = SendDlgItemMessage(hDlg, IDC_CHECK_START_SCORE, BM_GETCHECK, 0, 0);
			exi->filter_start_score = GetDlgItemInt(hDlg, IDC_EDIT_START_SCORE, NULL, FALSE);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_filter - tB^[ݒʕ\
 */
BOOL show_filter(const HINSTANCE hInst, const HWND hWnd, EXTRACT_INFO *exi)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_FILTER), hWnd, filter_proc, (LPARAM)exi);
}
/* End of source */
